package Controller;

import Domain.NeuralNetwork;

import javax.imageio.ImageIO;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.util.Vector;

import Sound.PlayTabs;


public class Controller {
    private NeuralNetwork m_neuralNetwork;
    private PlayTabs      m_playTab;
    private Vector        m_guitarString1;
    private Vector        m_guitarString2;
    private Vector        m_guitarString3;
    private Vector        m_guitarString4;
    private Vector        m_guitarString5;
    private Vector        m_guitarString6;

    public Controller(){
        m_neuralNetwork = new NeuralNetwork();
        m_playTab       = new PlayTabs();
        m_guitarString1 = new Vector();
        m_guitarString2 = new Vector();
        m_guitarString3 = new Vector();
        m_guitarString4 = new Vector();
        m_guitarString5 = new Vector();
        m_guitarString6 = new Vector();


    }

    public void Reset(){
       m_guitarString1 = new Vector();
       m_guitarString2 = new Vector();
       m_guitarString3 = new Vector();
       m_guitarString4 = new Vector();
       m_guitarString5 = new Vector();
       m_guitarString6 = new Vector();
    }

    //  ********    LEARN THE NEURAL NETWORK   ***********
    //*****************************************************

    public void Learn(){
        m_neuralNetwork.Learn();
    }

    //*********     TAB RECOGNITION         *************
    //***************************************************

    public boolean TabRecognition(String fileName){
       BufferedImage img = null;
       int xOffset = 0;
       int yOffset = 0;
       try{
            img = ImageIO.read(new File(fileName));
       }
       catch (IOException e) {
           return false;
       }

      if (img == null)
              return false;
      //Reach to the starting point @todo

     //Going on A Line For Each  Guitar String
        m_guitarString1 = goingOnALine(img,xOffset,yOffset);
        m_guitarString2 = goingOnALine(img,xOffset,yOffset+Library.Definitions.Y_INTERVAl);
        m_guitarString3 = goingOnALine(img,xOffset,yOffset+Library.Definitions.Y_INTERVAl*2);
        m_guitarString4 = goingOnALine(img,xOffset,yOffset+Library.Definitions.Y_INTERVAl*3);
        m_guitarString5 = goingOnALine(img,xOffset,yOffset+Library.Definitions.Y_INTERVAl*4);
        m_guitarString6 = goingOnALine(img,xOffset,yOffset+Library.Definitions.Y_INTERVAl*5);
        return true;

    }


    //PRIVATE FUNCTION
    //Going on a line(1 string ) through x -axis and recognize the tabs
    private Vector goingOnALine(BufferedImage img,int xOffset, int yOffset){
        Vector currentGridInputVector;
        Vector currentGridOutputVector;
        Vector guitarStringOutputVector = new Vector();
        while (( xOffset+ Library.Definitions.GRID_WIDTH) <= img.getWidth()){
            currentGridInputVector  = Data.ReadImg.getVectorInput(img,xOffset,yOffset);
            currentGridOutputVector = m_neuralNetwork.Recognize(currentGridInputVector);
            int recognitionTab      = Library.Definitions.maxElementIndexInVector(currentGridOutputVector);
            guitarStringOutputVector.addElement(new Integer(recognitionTab));
            xOffset += Library.Definitions.X_INTERVAl;
        }
        return guitarStringOutputVector;
    }
    //*************         PLAY        **************
    //************************************************

    public void play(){
        int[] GS1 = Sound.TabsToNotes.getNotesArr(m_guitarString1,1);
        int[] GS2 = Sound.TabsToNotes.getNotesArr(m_guitarString2,2);
        int[] GS3 = Sound.TabsToNotes.getNotesArr(m_guitarString3,3);
        int[] GS4 = Sound.TabsToNotes.getNotesArr(m_guitarString4,4);
        int[] GS5 = Sound.TabsToNotes.getNotesArr(m_guitarString5,5);
        int[] GS6 = Sound.TabsToNotes.getNotesArr(m_guitarString6,6);
        m_playTab.play(GS1, GS2, GS3, GS4, GS5, GS6);
    }

     //             PRINT STRINGS
    //             ****************
     public void printGuitarStrings(){
        System.out.println("****STRING-1****");
        for (int i = 0 ; i < m_guitarString1.size() ; ++i){
            System.out.print(((Integer)m_guitarString1.elementAt(i)).intValue()+ ",");
        }
        System.out.println();
        System.out.println("****STRING-2****");
        for (int i = 0 ; i < m_guitarString2.size() ; ++i){
            System.out.print(((Integer)m_guitarString2.elementAt(i)).intValue()+ ",");
        }
        System.out.println();
        System.out.println("****STRING-3****");
        for (int i = 0 ; i < m_guitarString3.size() ; ++i){
            System.out.print(((Integer)m_guitarString3.elementAt(i)).intValue()+ ",");
        }
        System.out.println();
        System.out.println("****STRING-4****");
        for (int i = 0 ; i < m_guitarString4.size() ; ++i){
            System.out.print(((Integer)m_guitarString4.elementAt(i)).intValue()+ ",");
        }
        System.out.println();
        System.out.println("****STRING-5****");
        for (int i = 0 ; i < m_guitarString5.size() ; ++i){
            System.out.print(((Integer)m_guitarString5.elementAt(i)).intValue()+ ",");
        }
        System.out.println();
        System.out.println("****STRING-6****");
        for (int i = 0 ; i < m_guitarString6.size() ; ++i){
            System.out.print(((Integer)m_guitarString6.elementAt(i)).intValue()+ ",");
        }

    }
}



