package Domain;

import java.util.Vector;
import java.util.Enumeration;


public class Layer {

    private Vector   m_neurons;
    private int      m_numOfNeurons;

 public Layer(String l,int numOfNeurons){
    String label;
    m_numOfNeurons = numOfNeurons;
    m_neurons = new Vector();
    for(int i = 0 ; i < numOfNeurons ; i++){
         label = new String(l) + String.valueOf(i);
         m_neurons.addElement(new Neuron(label));
    }
 }
 //*****************     Getter And Setter        *******************
 //***************************************************************

 public int getNumOfNeurons() {
        return m_numOfNeurons;
    }

 public Vector getNeurons() {
        return m_neurons;
    }

 public Neuron getNeuron(int i){
    int         j=0;
    boolean     found=false;
    Neuron      neuron=null;
    Enumeration e = m_neurons.elements();
    while(e.hasMoreElements()){
        neuron = (Neuron)e.nextElement();
        if (i==j){
          found = true;
          break;
        }
        else j++;
       }
    if (found==false){
        neuron = null;
    }
    return neuron;
 }

 //*******************   BACKPROPAGATION ALGORITHM   ********
  //**********************************************************
  // computeOutput
  // computeBackpropDelta for output Neuron
  // computeBackpropDelta for hidden layer Neuron
  // computeWeight

 public void computeOutputs(){
    Neuron neuron;
    Enumeration e = m_neurons.elements();
    while(e.hasMoreElements()){
        neuron = (Neuron)e.nextElement();
        neuron.computeOutput();
    }
 }

 public void computeBackpropDeltas(Vector s){ // for output neurons
    Neuron neuron;
    Enumeration e = m_neurons.elements();
    Enumeration d = s.elements();
    while(e.hasMoreElements()){
        neuron = (Neuron)e.nextElement();
        neuron.computeBackpropDelta(((Double)d.nextElement()).doubleValue());
    }
 }

 public void computeBackpropDeltas(){ // for hidden neurons
     Neuron neuron;
     Enumeration e = m_neurons.elements();
     while(e.hasMoreElements()){
        neuron = (Neuron)e.nextElement();
        neuron.computeBackpropDelta();
     }
 }

 public void computeWeights(){
     Neuron neuron;
     Enumeration e = m_neurons.elements();
     while(e.hasMoreElements()){
        neuron = (Neuron)e.nextElement();
        neuron.computeWeight();
     }
 }

 public void printLayer(){
     Neuron neuron;
     Enumeration e = m_neurons.elements();
     while(e.hasMoreElements()){
        neuron = (Neuron)e.nextElement();
        neuron.printNeuron();
     }
 }
}



