package Domain;

import java.util.Vector;


public class NeuralNetwork {

 Perceptron m_perceptron;

 public NeuralNetwork(){
    //Create 2 Hidden Layer
    int inputsNeurons   = Library.Definitions.NUM_OF_INPUT_NEURONS;
    int hidden1Neurons  = Library.Definitions.NUM_OF_HIDDEN1_NEURONS;
    int hidden2Neurons  = Library.Definitions.NUM_OF_HIDDEN2_NEURONS;
    int outputsNeurons  = Library.Definitions.NUM_OF_OUTPUT_NEURONS;
    m_perceptron = new Perceptron(inputsNeurons,outputsNeurons);
    m_perceptron.addLayer(hidden1Neurons,"H1");
    m_perceptron.addLayer(hidden2Neurons,"H2");

    //Connect the Layers

    //Connect input layer -> Hidden layer 1
    for (int input = 0 ; input < inputsNeurons ; ++input){
        for (int hidden1 = 0 ; hidden1 < hidden1Neurons ; ++hidden1 ){
            m_perceptron.connect(0,input,1,hidden1);
        }
    }

    //Connect Hidden1 Layer -> Hidden layer 2
    for (int hidden1 = 0 ; hidden1 < hidden1Neurons ; ++hidden1){
        for (int hidden2 = 0 ; hidden2 < hidden2Neurons ; ++hidden2 ){
            m_perceptron.connect(1,hidden1,2,hidden2);
        }
    }

    //Connect Hidden2 Layer -> Output Layer
     for (int hidden2 = 0 ; hidden2 < hidden2Neurons ; ++hidden2){
        for (int output = 0 ; output < outputsNeurons ; ++output ){
            m_perceptron.connect(2,hidden2,3,output);
        }
    }

    //Add Samples
     m_perceptron.setSamples(Data.Samples.getInputSamples(),
                             Data.Samples.getOutputSamples());

 }
 //             Supervised Learning
 //           -------------------------
 public void Learn(){
    m_perceptron.learn(Library.Definitions.NUMBER_OF_ITERATIONS);
 }

 //                  Recognize
 //             ------------------------
 
 public Vector Recognize(Vector input){
     return m_perceptron.recognize(input);
 }

 //                 Print
 //              ---------------------

 public void printNeuralNetwork(){
     m_perceptron.printPerceptron();
 }

}



