package GUI;

import javax.swing.*;
import javax.imageio.ImageIO;
import java.awt.*;
import java.awt.image.BufferedImage;

import Controller.Controller;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.io.File;
import java.io.IOException;


public class GUI extends JFrame
   {
       private Controller m_controller;

       private JMenuBar menu;
       private JMenu m1,m2,m3;
       private JPanel LoadFilePanel;
       private JButton
   btnLearn,btnOpenFile,btnPlay,btnExit;
       private JPanel pMain,pSouth,pNorth,pCenter;
       private JTextArea tac;
       private JTextField fileNameField;
       private JLabel lbllogo;
       private ActionListenerLearn LearnListener;
       private ActionListenerOpen OpenFileListener;
       private ActionListenerPlay PlayListener;
       private ActionListenerExit ExitListener;

       //private JPanel LoadFilePanel;


       public GUI()
       {
         BufferedImage img = null;
         BufferedImage img1 = null;

       try{
            img = ImageIO.read(new File("menu1.bmp"));
            img1 = ImageIO.read(new File("menutabs.bmp"));
       }
       catch (IOException e) {

       }

         ImageIcon imgIcon    = new ImageIcon(img);
         ImageIcon imgIcon1    = new ImageIcon(img1);

         JLabel imgLabel      = new JLabel(imgIcon);
          JLabel imgLabel1      = new JLabel(imgIcon1);

           //initialization panel

          pMain = new JPanel();
          pNorth = new JPanel();
          pSouth = new JPanel();
          pCenter = new JPanel();


         m_controller         = new Controller();
         LoadFilePanel       = new JPanel();
         //text area initialization
         tac = new JTextArea(1,3);
         fileNameField = new JTextField(10);

        LearnListener        = new ActionListenerLearn(m_controller,tac);
        OpenFileListener     = new ActionListenerOpen(m_controller, tac,fileNameField,imgLabel1, pCenter);
        PlayListener         = new ActionListenerPlay(m_controller,tac);
        ExitListener         = new ActionListenerExit();


           //menu bar and menu item initialization




         tac.setText(new StringBuffer().append("I Need To Learn First").toString());

         tac.setForeground(Color.blue);
         tac.setEditable(false);

         //button intialization
         btnLearn = new JButton("LEARN");

         btnLearn.setToolTipText("Learn With The Training Set");
         btnLearn.addActionListener(LearnListener);

         btnOpenFile = new JButton("LOAD FILE");
         btnOpenFile.setToolTipText("Load Bmp Image With Tabs");
         btnOpenFile.addActionListener(OpenFileListener);
         LoadFilePanel.add(btnOpenFile);
         LoadFilePanel.add(fileNameField);
           //btnOpenFile.add(fileNameField);

         btnPlay = new JButton("PLAY");
         btnPlay.setToolTipText("Play The Tabs");

         btnPlay.addActionListener(PlayListener);


         btnExit = new JButton("EXIT");
         btnExit.setToolTipText("Out of Program");
         btnExit.addActionListener(ExitListener);



         // lbllogo = new JLabel(new
        //ImageIcon("tabsFormat.bmp"),JLabel.CENTER);

          //add menuitem to menu







          pMain.add(btnLearn);
          //pMain.add(btnOpenFile);
          //pMain.add(fileNameField);
          pMain.add(btnPlay);
          pMain.add(btnExit);



          pMain.setLayout(new BoxLayout(pMain,BoxLayout.Y_AXIS));
          pMain.setBorder(BorderFactory.createTitledBorder("OPTIONS"));
          pMain.setLayout(new GridLayout(6,1));
          pMain.setBackground(Color.BLUE);

          pCenter.setBackground(Color.white);
          pCenter.setLayout(new BoxLayout(pMain,BoxLayout.Y_AXIS));
          pCenter.setLayout(new GridLayout(2,1));
          pCenter.add(imgLabel);
           pCenter.add(imgLabel1);

          pNorth.add(tac);
          pNorth.setBackground(Color.blue);

          pSouth.add(LoadFilePanel);
          pSouth.setBackground(Color.blue);

          this.getContentPane().add(pMain,"West");
          this.getContentPane().add(pCenter,"Center");
          this.getContentPane().add(pNorth,"North");
          this.getContentPane().add(pSouth,"South");
          this.setSize(500,500);
          this.setResizable(false);
          this.setLocation(150,150);
          this.setTitle("GUITAR TABS RECOGNITION");
          this.show();
          }



          public static void main(String[] args)
          {
           GUI lg = new GUI();
          }
         }


        class ActionListenerLearn implements ActionListener {

            private Controller m_controller;
            private JTextArea m_textField;
            ActionListenerLearn(Controller controller,JTextArea tac){
                m_controller = controller;
                m_textField  = tac;
            }
            public void actionPerformed(ActionEvent event){
                m_controller.Learn();
                m_textField.setText("Complete Learning");
            }
        }

         class ActionListenerOpen implements ActionListener {

            private Controller m_controller;
            private JTextField m_fileNameField;
            private JTextArea  m_textField;
            private JLabel     m_jLabel;
            private JPanel     m_jPanel;
            ActionListenerOpen(Controller controller,JTextArea tac,JTextField fileNameArea,JLabel imgLabel,JPanel jp){
                m_controller        = controller;
                m_fileNameField     = fileNameArea;
                m_textField         = tac;
                m_jLabel            = imgLabel;
                m_jPanel            = jp;
            }
            public void actionPerformed(ActionEvent event){
                String fileName = m_fileNameField.getText();
                boolean openOk  = m_controller.TabRecognition(fileName);
                if (openOk){
                    m_textField.setText("File " + fileName +" Loaded");
                }
                else{
                    m_textField.setText("Error With " + fileName );
                }

                 BufferedImage img = null;
                 try{
                     img = ImageIO.read(new File(fileName));

                }
                catch (IOException e) {
                }

                if (img!=null){
                    ImageIcon imgIcon =  new ImageIcon(img);
                    m_jPanel.remove(m_jLabel);
                    m_jLabel = new JLabel(imgIcon);

                    m_jPanel.add(m_jLabel);
                }






            }
        }

         class ActionListenerPlay implements ActionListener {

            private Controller m_controller;
            private JTextArea m_textField;
            ActionListenerPlay(Controller controller,JTextArea tac){
                m_controller = controller;
                m_textField  = tac;
            }
            public void actionPerformed(ActionEvent event){
                m_textField.setText("Now Playing");
                m_controller.play();

            }
        }


         class ActionListenerExit implements ActionListener {

            public void actionPerformed(ActionEvent event){
                System.exit(1);
            }
        }










