package Sound;

import javax.sound.midi.*;
import java.util.Vector;


public class PlayTabs {
    private final int VELOCITY = 127;

    private int tabsFilter(int tab){
        if (tab == -1)
            return 0;
        else
            return VELOCITY;
    }
    public void play(int[] GS1,int[] GS2,int[] GS3,
                     int[] GS4,int[] GS5,int[] GS6){

         try
        {
// Locate the default synthesizer
            Synthesizer synth = MidiSystem.getSynthesizer();

// Open the synthesizer
            synth.open();

// Get the available Midi channels - there are usually 16
            MidiChannel channels[] = synth.getChannels();
//Get CLEAN GUITAR SOUND
            Soundbank bank = synth.getDefaultSoundbank();
            synth.loadAllInstruments(bank);
            Instrument instrs[] = synth.getLoadedInstruments();
            Instrument naylonGuitarInstrument = null;

            for (int i=0; i < instrs.length; i++){
                if (instrs[i].getName().equals("Nylon Str Guitar")){
                    naylonGuitarInstrument = instrs[i];
                     break;
                }
            }

            if (naylonGuitarInstrument == null){
                   System.out.println("Can't find the beach");
                   System.exit(0);
            }

// Get the information describing the Seashore instrument - the
// patch contains the soundbank and program number
            Patch naylonGuitarPatch = naylonGuitarInstrument.getPatch();

// Set 6 channels to use the Seashore instrument
             for (int i = 1 ; i <=6 ; ++i){
                channels[i].programChange(naylonGuitarPatch.getBank(),
                naylonGuitarPatch.getProgram());
             }



//START PLAYING NOTES
            for (int i = 0 ; i < GS1.length ; ++i){
                //String 1
                int guitarStr1 = GS1[i];
                int velocity1   = tabsFilter(guitarStr1);
                channels[1].noteOn(guitarStr1,velocity1);
                //String 2
                int guitarStr2 = GS2[i];
                int velocity2   = tabsFilter(guitarStr2);
                channels[2].noteOn(guitarStr2,velocity2);
                //String 3
                int guitarStr3 = GS3[i];
                int velocity3   = tabsFilter(guitarStr3);
                channels[3].noteOn(guitarStr3,velocity3);
                //String 4
                int guitarStr4 = GS4[i];
                int velocity4   = tabsFilter(guitarStr4);
                channels[4].noteOn(guitarStr4,velocity4);
                //String 5
                int guitarStr5 = GS5[i];
                int velocity5   = tabsFilter(guitarStr5);
                channels[5].noteOn(guitarStr5,velocity5);
                //String 6
                int guitarStr6 = GS6[i];
                int velocity6  = tabsFilter(guitarStr6);
                channels[6].noteOn(guitarStr6,velocity6);

                //Wait
                Thread.sleep(1000);

                //Stop playing
                channels[1].noteOff(guitarStr1);
                channels[2].noteOff(guitarStr2);
                channels[3].noteOff(guitarStr3);
                channels[4].noteOff(guitarStr4);
                channels[5].noteOff(guitarStr5);
                channels[6].noteOff(guitarStr6);
            }


// Close the synthesizer device
            synth.close();

// Terminate the program
            //System.exit(0);
        }
        catch (Exception exc)
        {
            exc.printStackTrace();
        }
    }

}

